/* @(#)mandel_init.h	1.2 91/03/11 TIRPC 1.0 */
/*
 * file : mandel_init.h
 */
/* 
 *
 * MultiMandel was written by Carsten Ruseng Jakobsen, Ida Marie
 * Jensen, Thim Otskov, Claus Priisholm and Jeppe Sommer at the
 * University of Aalborg in Denmark spring 1989, and is provided for
 * unrestricted use provided that this legend is included on all tape
 * media and as a part of the software program in whole or part.
 * Users may copy or modify MultiMandel without charge, but are not
 * authorized to license or distribute it to anyone else except as
 * part of a product or program developed by the user.
  
 * MultiMandel IS PROVIDED AS IS WITH NO WARRANTIES OF ANY KIND
 * INCLUDING THE WARRANTIES OF DESIGN, MERCHANTIBILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE, OR ARISING FROM A COURSE OF DEALING, USAGE OR
 * TRADE PRACTICE.
 * 
 * MultiMandel is provided with no support and without any obligation
 * on the part of the authors, to assist in its use, correction,
 * modification or enhancement.
 * 
 * THE AUTHORS SHALL HAVE NO LIABILITY WITH RESPECT TO THE
 * INFRINGEMENT OF COPYRIGHTS, TRADE SECRETS OR ANY PATENTS BY
 * MultiMandel OR ANY PART THEREOF.
 * 
 * In no event will the authors and/or University of Aalborg be liable
 * for any lost revenue or profits or other special, indirect and
 * consequential damages, even if the authors and/or University of
 * Aalborg has been advised of the possibility of such damages.
 * 
 * University of Aalborg
 * Strandvejen 19
 * 9000 Aalborg
 * Denmark
 */


#define MANDEL_SIZE 600
#define MAX_CELLS 256
#define NO_SPLIT 20

#define MANDEL_A -1.700000000
#define MANDEL_B -1.200000000
#define MANDEL_L  2.400000000

#define PIX_SIZE 4000

#define MAX_SVR 25
#define MAX_JOBS 100

#define TRUE 1
#define FALSE 0

#define ACCOUNT_FILE "account"
#define SMALL_FONT "/usr/lib/fonts/fixedwidthfonts/screen.r.7"
#define MEDIUM_FONT "/usr/lib/fonts/fixedwidthfonts/screen.r.14"

typedef struct Task {
    int socket[2];
    int pid;
    int busy;
} Task;

typedef struct Assignment 
{
    int die;
    int no;
    MandelCT ct;
} Assignment;

typedef struct Reply
{
    int reply;
    int no;
    PixMap pm;
} Reply;

typedef struct Server
{
    int count;
    char name[25];
} Server;
